
Ball = Core.class(Sprite)

-- this function creates a ball physical
function Ball:init(x, y, name)
	self.body = world:createBody{type = b2.DYNAMIC_BODY, position = {x = x, y = y}}

	self.name = name
	self.radius = 15
	self.directionX = 1
	self.directionY = 1
	self.speedX = 2.5
	self.speedY = 7.3

	self.shape = b2.CircleShape.new(self.radius, self.radius, self.radius)
	self.shape:set(self.radius, self.radius, self.radius)
	self.body:createFixture{shape = self.shape, density = 1, restitution = 0.2, friction = 0.3}

	self.sprite = Bitmap.new(Texture.new("ball" .. (self.radius * 2) .. ".png"))
	self.sprite:setAnchorPoint(0.5, 0.5)
	stage:addChild(self.sprite)
	actors[self.body] = self.sprite
	
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)	
end


function Ball:onEnterFrame()
	local x,y = self:getPosition()
	
	x = x + (self.speedX * self.directionX)
	y = y + (self.speedY * self.directionY)
	
	if x < self.radius then self.directionX = 1 end
	if x > gameMaxX - self.radius  then self.directionX = -1 end
	if y < self.radius  then self.directionY = 1 end
	if y > gameMaxY - self.radius then self.directionY = -1 end

	self:setPosition(x, y)
	self.sprite:setPosition(self:getPosition())
end
