Snake = Core.class(Sprite)

local snakeSize = 24
local sankeHidden = 5
local snakeBodyNb = 10
local snakeHalfSize = snakeSize / 2
local snakeVisible = snakeSize - sankeHidden
local snakeStepX = 0
local snakeStepY = 0
local snakeWaitInit = 2
local snakeWait


function Snake:init(name)
	self.body = {}
	self.sprite = {}
	self.name = {}

	-- Snake Head
	snakeCreate(self, name, 0, "snakehead" .. snakeSize	.. ".png", 200, 375)
	-- Snake Body
	local i
	for i=1, snakeBodyNb do
		snakeCreate(self, name, i, "snakebody" .. snakeSize	.. ".png", (200 - i * snakeVisible), 375)
	end
	
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end


function snakeCreate(Self, name, ind, bitmap, x, y)
	Self.body[ind] = world:createBody{type = b2.DYNAMIC_BODY, position = {x = x, y = y}}
	Self.name[ind] = name
	Self.shape = b2.CircleShape.new(snakeSize/2, snakeSize/2, snakeSize/2)
	Self.shape:set(snakeSize/2, snakeSize/2, snakeSize/2)
	Self.body[ind]:createFixture{shape = Self.shape, density = 1, restitution = 0.2, friction = 0.3}

	Self.sprite[ind] = Bitmap.new(Texture.new(bitmap))
	Self.sprite[ind]:setAnchorPoint(0.5, 0.5)
	stage:addChild(Self.sprite[ind])
	actors[Self.body[ind]] = Self.sprite[ind]
	Self.body[ind]:setPosition(x, y)
	Self.sprite[ind]:setPosition(x, y)
end


function Snake.MoveTo(snake, x, y)
	x = x - snakeHalfSize
	y = y - snakeHalfSize

	local ax, ay = snake.body[0]:getPosition()
	if x ~= ax then
		snakeStepX = x - ax
	else
		snakeStepX = 0
	end
	if y ~= ay then
		snakeStepY = y - ay
	else
		snakeStepY = 0
	end
	if snakeStepX == 0 and snakeStepY > 0 then
		snakeStepY = snakeVisible
	elseif snakeStepX == 0 and snakeStepY < 0 then
		snakeStepY = -snakeVisible
	elseif snakeStepY == 0 and snakeStepX > 0 then
		snakeStepY = snakeVisible
	elseif snakeStepY == 0 and snakeStepX < 0 then
		snakeStepY = -snakeVisible
	elseif snakeStepX ~= 0 and snakeStepY ~= 0 then
		local yx2 = (snakeStepY * snakeStepY) / (snakeStepX * snakeStepX)
		if snakeStepX > 0 and snakeStepY < 0 then
			snakeStepX = snakeVisible / math.sqrt(yx2 +1)
			snakeStepY = -snakeVisible / math.sqrt((1 / yx2) +1)
		elseif snakeStepX < 0 and snakeStepY > 0 then
			snakeStepX = -snakeVisible / math.sqrt(yx2 +1)
			snakeStepY = snakeVisible / math.sqrt((1 / yx2) +1)
		elseif snakeStepX < 0 and snakeStepY < 0 then
			snakeStepX = -snakeVisible / math.sqrt(yx2 +1)
			snakeStepY = -snakeVisible / math.sqrt((1 / yx2) +1)
		else
			snakeStepX = snakeVisible / math.sqrt(yx2 +1)
			snakeStepY = snakeVisible / math.sqrt((1 / yx2) +1)
		end
	end
	snakeWait = snakeWaitInit
end


function Snake:onEnterFrame(event)
	if snakeStepX ~= 0 or snakeStepY ~= 0 then
		snakeWait = snakeWait -1
		if snakeWait <= 0 then
			snakeWait = snakeWaitInit
			local hx, hy = self.body[0]:getPosition()
			local x = hx + snakeStepX
			local y = hy + snakeStepY
			
			if x >= gameMinX and y >= gameMinY and x <= (gameMaxX - snakeSize) and y <= (gameMaxY - snakeSize) then
				for i=snakeBodyNb,1,-1 do
					self.body[i]:setPosition(self.body[i-1]:getPosition())
					self.sprite[i]:setPosition(self.body[i-1]:getPosition())
				end
				self.body[0]:setPosition(x, y)
				self.sprite[0]:setPosition(x, y)
			else
				snakeStepX = 0
				snakeStepY = 0
			end
		end
	end

end
